
dontCrossYourPathTutorial = {}

dontCrossYourPathTutorial.id = "S_TUTORIAL_INSTRUCTIONS3"



function dontCrossYourPathTutorial:onBlockChanged(gameGrid, block)
	--dbg.print("dontCrossYourPathTutorial:onBlockChanged")
	if (block.isHidden == true) then
		if(not self:isActive())then
			tutorialsManager:contextTutorialScheduleAttempt(self.id)
		end
	else
		if(self:isActive()) then
			if(self.fillCount == nil) then
				self.fillCount = 0
			end
			self.fillCount = self.fillCount + 1
			if(self.fillCount >= 2)then
				self:close()
			end
		end
	end
end

function dontCrossYourPathTutorial:hintUsed(startFromX, startFromY)
	
end

function dontCrossYourPathTutorial:resetData()
	self.fillCount = 0
	self.rewindCount = 0
end


function dontCrossYourPathTutorial:dismissed()
	self:resetData()
	if(self:isActive()) then
		self:deactivate()
		tutorialsManager:closeCurrentTutorial()
	end
end

function dontCrossYourPathTutorial:hintButtonPressed()
	dbg.print("dontCrossYourPathTutorial:hintButtonPressed")
end

function dontCrossYourPathTutorial:close()--achieves and dismisses this tutorial
	if(self:isActive()) then
		tutorialsManager:savePerformedContextTutorial(self.id)
		self:resetData()
		self:deactivate()
		tutorialsManager:closeCurrentTutorial()
	end
end
--[[
function dontCrossYourPathTutorial:close()
	if(self:isActive()) then
		tutorialsManager:savePerformedContextTutorial()
		self:resetData()
		self:deactivate()
		tutorialsManager:closeCurrentTutorial()
	end
end
--]]
function dontCrossYourPathTutorial:deactivate()
	self.isActiveFlag = false
end

function dontCrossYourPathTutorial:activate()
	self.isActiveFlag = true
end

function dontCrossYourPathTutorial:isActive()
	return (self.isActiveFlag == true)
end

function dontCrossYourPathTutorial:levelComplete()
	if(self:isActive()) then
		self:close()
	end
end

function dontCrossYourPathTutorial:canceled()
	dbg.print("dontCrossYourPathTutorial:canceled")
	self:resetData()
	self:deactivate()
end

function dontCrossYourPathTutorial:onBlockRewinded(event)
	if(self:isActive()) then
		dbg.print("dontCrossYourPathTutorial:onBlockRewinded")
		if(self.rewindCount == nil) then
			self.rewindCount = 0
		end
		self.rewindCount = self.rewindCount + 1
		if(self.rewindCount >= 2)then
			self:close()
		end
	end
end

function dontCrossYourPathTutorial:update(dt)
	
end