
skippingButtonTutorial = {}

skippingButtonTutorial.id = "S_TUTORIAL_INSTRUCTIONS14"
skippingButtonTutorial.buttonVisible = false


function skippingButtonTutorial:onBlockChanged(gameGrid, block)
end

function skippingButtonTutorial:resetData()
end

function skippingButtonTutorial:dismissed()
	self:resetData()
	if(self:isActive()) then
		self:deactivate()
		tutorialsManager:closeCurrentTutorial()
	end
end

function skippingButtonTutorial:close()--achieves and dismisses this tutorial
	if(self:isActive()) then
		dbg.print("<>><<><><>< skippingButtonTutorial:close")
		tutorialsManager:savePerformedContextTutorial(self.id)
		self:resetData()
		self:deactivate()
		tutorialsManager:closeCurrentTutorial()
	end
end

function skippingButtonTutorial:deactivate()
	dbg.print("skippingButtonTutorial:deactivate")
	--dbg.print(dbg.getProcessedCallstack())
	self.isActiveFlag = false
end

function skippingButtonTutorial:activate()
	dbg.print("skippingButtonTutorial:activate")
	--dbg.print(dbg.getProcessedCallstack())
	self.isActiveFlag = true
	if(self.buttonVisible == false)then
		self:dismissed()
	end
end

function skippingButtonTutorial:isActive()
	if(self.isActiveFlag) then
		dbg.print("skippingButtonTutorial is Active ")
	else
		dbg.print("skippingButtonTutorial is NOT Active ")
	end
	return (self.isActiveFlag == true)
end

function skippingButtonTutorial:levelComplete()
	if(self:isActive()) then
		self:dismissed()
	end
end

function skippingButtonTutorial:hintUsed(startFromX, startFromY)

end

function skippingButtonTutorial:canceled()
	dbg.print("skippingButtonTutorial:canceled")
	self:resetData()
	self:deactivate()
end

function skippingButtonTutorial:hintButtonPressed()
	
end

function skippingButtonTutorial:skippingButtonUsed()
	dbg.print("skippingButtonTutorial:skippingButtonUsed")
	if(self:isActive()) then
		dbg.print("dbg point 1")	
		self:close()--achieved
	else
		--TODO add save tutorial here to achieve this tutorial even if it is not currently displayed
	end
end

function skippingButtonTutorial:checkActivateCriteria()
	local result = true
	if(tutorialsManager:getWorldId() == tostring(1) and tonumber(tutorialsManager:getLevelId()) <= 3 ) then
		result = false
	else
		if(tutorialsManager:isAContextTutorialActive()) then
			if(tutorialsManager:getCurrentActiveTutorialId() == hintSystemTutorial.id or tutorialsManager:getCurrentActiveTutorialId() == hintSystemUsageTutorial.id) then
				result = false
			end
		end	
	end
	return result
end

function skippingButtonTutorial:skipButtonInVisibleEvent()
	self.buttonVisible = false
	if(self:isActive()) then
		self:dismissed()
	end
end

function skippingButtonTutorial:skipButtonVisibleEvent()
	self.buttonVisible = true
	dbg.print("skippingButtonTutorial:skipButtonVisibleEvent")
	if(not self:isActive())then
		dbg.print("skippingButtonTutorial dbg 1")
		if(self:checkActivateCriteria()) then
			dbg.print("skippingButtonTutorial dbg 2")
			tutorialsManager:contextTutorialScheduleAttempt(self.id)
		end
	end
end

function skippingButtonTutorial:onBlockRewinded(event)

end

function skippingButtonTutorial:update(dt)

end