--

PROPS = 
{
--PROP_CHICKEN_HOUSE
 {source="Assets/Props/chickenHouse.png", width=128,height=178,numFrames=1, animStart=1,animCount=1, zOrder=1},
 --PROP_FARMER_HOUSE
 {source="Assets/Props/farmersHouse.png", width=173,height=285,numFrames=1, animStart=1,animCount=1, zOrder=1},
 --PROP_GRAIN_HOUSE
 {source="Assets/Props/grainStore.png", width=132,height=188,numFrames=1, animStart=1,animCount=1, zOrder=1},
 --PROP_WINDTURBINE
 {source="Assets/Props/windTurbine_atlas.png", width=238,height=325,numFrames=30, animStart=1,animCount=30, zOrder=16},
 --PROP_TRACTOR
 {source="Assets/Props/tractor_atlas.png", width=170,height=214,numFrames=28, animStart=1,animCount=28, zOrder=1},
 --PROP_CURVED_PATH
 {source="Assets/Props/curvedTrack.png", width=247,height=306,numFrames=1, animStart=1,animCount=1, zOrder=1},
 --PROP_HORIZONTAL_PATH
 {source="Assets/Props/horizontalTrack1.png", width=765,height=52,numFrames=1, animStart=1,animCount=1, zOrder=1},
 --PROP_VERTICAL_PATH
 {source="Assets/Props/verticalTrack.png", width=67,height=703,numFrames=1, animStart=1,animCount=1, zOrder=1},
 --PROP_FLOWERS_1
 {source="Assets/Props/flowers1_2_atlas.png", width=103,height=92,numFrames=20, animStart=1,animCount=10, zOrder=1, minWait=2, maxWait=4},
 --PROP_FLOWERS_2
 {source="Assets/Props/flowers1_2_atlas.png", width=103,height=92,numFrames=20, animStart=1,animCount=10, zOrder=1, minWait=2, maxWait=4},	-- use flowers 1 for this too, as flowers 2 shakes around too violently and looks weird
--PROP_CHICKEN_1
 {source="Assets/Props/Chicken1_atlas.png", width=64,height=64,numFrames=25, animStart=1,animCount=25, zOrder=1},
--PROP_CHICKEN_2
 {source="Assets/Props/Chicken2_3_atlas.png", width=80,height=80,numFrames=45, animStart=1,animCount=20, zOrder=1, minWait=2, maxWait=4},
--PROP_CHICKEN_3
 {source="Assets/Props/Chicken2_3_atlas.png", width=80,height=80,numFrames=45, animStart=21,animCount=25, zOrder=1, minWait=2, maxWait=4},
--PROP_PIG_1
 {source="Assets/Props/pig1_2_atlas.png", width=84,height=60,numFrames=50, animStart=1,animCount=25, zOrder=1, minWait=2, maxWait=4},
--PROP_PIG_2
 {source="Assets/Props/pig1_2_atlas.png", width=84,height=60,numFrames=50, animStart=26,animCount=25, zOrder=1, minWait=2, maxWait=4},
 --PROP_COW
 {source="Assets/CowChewingGrass.png", width=128,height=155,numFrames=10, animStart=1,animCount=10, zOrder=1, minWait=1, maxWait=2},
 --PROP_TREE_1
 {source="Assets/treeAtlas.png", width=128,height=176,numFrames=4, animStart=1,animCount=1, zOrder=1},--
 --PROP_TREE_2
 {source="Assets/treeAtlas.png", width=128,height=176,numFrames=4, animStart=2,animCount=1, zOrder=1},--
 --PROP_TREE_3
 {source="Assets/treeAtlas.png", width=128,height=176,numFrames=4, animStart=3,animCount=1, zOrder=1},--
 --PROP_TREE_4
 {source="Assets/treeAtlas.png", width=128,height=176,numFrames=4, animStart=4,animCount=1, zOrder=1},--
 --PROP_SMALLBUSH_1
 {source="Assets/Props/smallBush.png", width=83,height=74,numFrames=2, animStart=1,animCount=1, zOrder=1},
 --PROP_SMALLBUSH_2
 {source="Assets/Props/smallBush.png", width=83,height=74,numFrames=2, animStart=2,animCount=1, zOrder=1},
 --PROP_LARGEBUSH_1
 {source="Assets/Props/BigBushes.png", width=118,height=111,numFrames=2, animStart=1,animCount=1, zOrder=1},
 --PROP_LARGEBUSH_2
 {source="Assets/Props/BigBushes.png", width=118,height=111,numFrames=2, animStart=2,animCount=1, zOrder=1},
  --PROP_HAYSTACK_1
 {source="Assets/Props/hayStack1.png", width=134,height=133,numFrames=1, animStart=1,animCount=1, zOrder=1},
 --PROP_HAYSTACK_2
 {source="Assets/Props/hayStack2.png", width=121,height=125,numFrames=1, animStart=1,animCount=1, zOrder=1},
  --PROP_HAYSTACK_3
 {source="Assets/Props/hayStack3.png", width=132,height=127,numFrames=1, animStart=1,animCount=1, zOrder=1},
  --PROP_WIREFENCE_1
 {source="Assets/Props/HorizontalFence.png", width=731,height=66,numFrames=2, animStart=1,animCount=1, zOrder=15},
  --PROP_WIREFENCE_2
 {source="Assets/Props/verticalFenceLeft.png", width=45,height=749,numFrames=1, animStart=1,animCount=1, zOrder=38},
  --PROP_WIREFENCE_3
 {source="Assets/Props/verticalFenceRight.png", width=63,height=752,numFrames=1, animStart=1,animCount=1, zOrder=38},
  --PROP_STONEWALL
 {source="Assets/Props/stonewall.png", width=269,height=61,numFrames=1, animStart=1,animCount=1, zOrder=1},
  --PROP_FIREFLIES
 {source="Assets/Props/fireFlies.png", width=128,height=128,numFrames=42, animStart=1,animCount=25, zOrder=41},
  --PROP_LAMPOSTS
 {source="Assets/Props/lampost1.png", width=31,height=95,numFrames=1, animStart=1,animCount=1, zOrder=41},
  --PROP_HORIZONTAL_PATH
 {source="Assets/Props/horizontalTrack1.png", width=765,height=52,numFrames=1, animStart=1,animCount=1, zOrder=1},
  --PROP_WIREFENCE_4
 {source="Assets/Props/HorizontalFence.png", width=731,height=66,numFrames=2, animStart=2,animCount=1, zOrder=39},
  --PROP_LAMPOSTS_2
 {source="Assets/Props/lampost2.png", width=31,height=97,numFrames=1, animStart=1,animCount=1, zOrder=41},
   --PROP_FIREFLIES
 {source="Assets/Props/fireFlies.png", width=128,height=128,numFrames=42, animStart=26,animCount=17, zOrder=41},
}

gameBG = {}
gameBG_mt = { __index = gameBG }

function gameBG.create(scene,top,bot,left,right, overlay, propsFile, cloudColor)
	local instance = {}
	setmetatable( instance, gameBG_mt)
	instance:init(scene,top,bot,left,right, overlay, propsFile, cloudColor)
	return instance
end

function gameBG:init(scene,top,bot,left,right, overlay, propsFile, cloudColor)
	self.props = {}
	local pixelGridSize = 640 * UI_SCALE
	local xGridOffset = (director.displayWidth - pixelGridSize) / 2
	self.scene = scene

    self.node = director:createNode()
    self.node.isTouchable = false
    scene:addChild( self.node)

	self.propsNode = director:createNode({
        x=director.displayWidth / 2,y=director.displayHeight / 2,
        xScale = UI_SCALE, yScale = UI_SCALE
    })
    self.propsNode.isTouchable = false
	scene:addChild( self.propsNode)

	local topBG = director:createSprite({
		xAnchor = 0.5,
		yAnchor = 0,
		zOrder = 0,
		xScale = UI_SCALE, yScale = UI_SCALE,
		y = pixelGridSize + (director.displayHeight - pixelGridSize) * (1/3),
		x = director.displayWidth / 2,
		source = top,
        isTouchable = false
	})
	self.node:addChild(topBG)
	
	local botBG = director:createSprite({
		xAnchor = 0.5,
		yAnchor = 1,
		zOrder = 0,
		xScale = UI_SCALE, yScale = UI_SCALE,
		y = (director.displayHeight - pixelGridSize) * (1/3),
		x = director.displayWidth / 2,
		source = bot,
        isTouchable = false
	})
	self.node:addChild(botBG)
	
	local leftBG = director:createSprite({
		xAnchor = 1,
		yAnchor = 0,
		zOrder = 0,
		xScale = UI_SCALE, yScale = UI_SCALE,
		y = botBG.y,
		x = xGridOffset,
		source = left,
        isTouchable = false
	})
   	self.node:addChild(leftBG)

	local rightBG = director:createSprite({
		xAnchor = 0,
		yAnchor = 0,
		zOrder = 0,
		xScale = UI_SCALE, yScale = UI_SCALE,
		y = botBG.y,
		x = director.displayWidth - xGridOffset,
		source = right,
        isTouchable = false
	})
	self.node:addChild(rightBG)
	
	self.overlayProps = {}
	self.animatedProps = {}	-- list of props that need to be animated at intervals
	
	if overlay ~= "none" then
		self.overlay = director:createSprite({
            source = overlay,
            xAnchor = 0.5,
            yAnchor = 0.5,
            x = director.displayWidth / 2,
            y = director.displayHeight / 2,
            xScale = UI_SCALE,
            yScale = UI_SCALE,
            zOrder = 41,
            blendMode = "multiply",
            isTouchable = false})
		scene:addChild(self.overlay)
	end
	
	local file = io.open(propsFile, "r")
	local propsString = file:read()
	file:close()
	
	local pattern = string.format("([^%s]+)", ",")
	local fieldPattern = string.format("([^%s]+)", ":")
	local row={}
    propsString:gsub(pattern, function(c) row[#row+1] = c end)
	local props = {}
	for i = 1, #row do
		fields = {}
		row[i]:gsub(fieldPattern, function(c) fields[#fields+1] = c end)
		props[i] = {propId = tonumber(fields[1]), x=tonumber(fields[2]), y=tonumber(fields[3])}
		
        local propSprite = self:createProp(props[i])
		
		-- If this prop should only animate intermittently...
		if PROPS[props[i].propId].minWait ~= nil then
		
			-- Stop it from looping now, so we can make it animate randomly later on
			propSprite:play({startFrame=PROPS[props[i].propId].animStart + PROPS[props[i].propId].animCount - 1, loopCount=1})
			propSprite.minWait = PROPS[props[i].propId].minWait
			propSprite.maxWait = PROPS[props[i].propId].maxWait
			propSprite.animStart = PROPS[props[i].propId].animStart
			propSprite.frameCount = math.random(propSprite.minWait*30,propSprite.maxWait*30)
			table.insert(self.animatedProps, propSprite)
		end
		
		if PROPS[props[i].propId].zOrder > 1 then
			propSprite.xScale = UI_SCALE
			propSprite.yScale = UI_SCALE
			propSprite.x = (propSprite.x * UI_SCALE) + director.displayWidth / 2
			propSprite.y = (propSprite.y * UI_SCALE) + director.displayHeight / 2
    		scene:addChild(propSprite)
			table.insert(self.overlayProps, propSprite)
        else
		    self.propsNode:addChild(propSprite)
		end
	end
	
    self.clouds = director:createNode()
    self.clouds.zOrder = 42
    scene:addChild( self.clouds)

	self.clouds[1] = director:createSprite({alpha=0.7,color=cloudColor,x= director.displayWidth *1.5 ,y = director.displayHeight,xScale=UI_SCALE, yScale=UI_SCALE, xAnchor = 0.5, yAnchor = 0.5, zOrder = 42, source ="Assets/cloud02G40.png"})
	self.clouds[2] = director:createSprite({alpha=0.7,color=cloudColor,x= director.displayWidth *1.7 ,y = 0,xScale=UI_SCALE, yScale=UI_SCALE, xAnchor = 0.5, yAnchor = 0.5, zOrder = 42, source ="Assets/cloud02G40.png"})
	self.clouds[3] = director:createSprite({alpha=0.5,color=cloudColor,x= director.displayWidth *1.7 ,y = director.displayHeight - 96 * UI_SCALE,xScale=UI_SCALE / 1.5, yScale=UI_SCALE / 2, xAnchor = 0.5, yAnchor = 0.5, zOrder = 42, source ="Assets/cloud02G40.png"})
	self.clouds[4] = director:createSprite({alpha=0.5,color=cloudColor,x= director.displayWidth *1.7 ,y = 64 * UI_SCALE,xScale=UI_SCALE / 2, yScale=UI_SCALE / 2, xAnchor = 0.5, yAnchor = 0.5, zOrder = 42, source ="Assets/cloud02G40.png"})

    for i = 1,4 do
	    self.clouds:addChild(self.clouds[i])
        -- And start the cloud moving
        self["cloudTweenComplete"..i](self.clouds[i])
    end
	
	system:addEventListener("update", self)
end

function gameBG:update(event)

	for i = 1, #self.animatedProps do
	
		self.animatedProps[i].frameCount = self.animatedProps[i].frameCount - 1
		
		-- If the counter for this prop has run down, play the animation and then wait again
		if self.animatedProps[i].frameCount <= 0 then
		
--			self.animatedProps[i]:play({startFrame=1, loopCount=1})
			self.animatedProps[i]:_play(1,1)

			self.animatedProps[i].frameCount = math.random(self.animatedProps[i].minWait*30,self.animatedProps[i].maxWait*30)
--			dbg.print("Playing animation on prop " .. i .. ", then waiting for " .. self.animatedProps[i].frameCount .. " frames")
		end
	end
end

function gameBG:clear()
    self.props = nil
	
	self.propsNode:removeFromParent()
	
	if self.overlay ~= nil then
		self.overlay:removeFromParent()
	end
	self.overlay = nil

    for i = 1,#self.overlayProps do
        self.overlayProps[i]:removeFromParent()
    end
	
	self.overlayProps = nil
	self.animatedProps = nil
    self.propsNode = nil
    self.clouds:removeFromParent()
    self.clouds = nil
    self.node:removeFromParent()
    self.node = nil

	system:removeEventListener("update", self)
end

function gameBG.cloudTweenComplete1(target)
	target.x = director.displayWidth *1.5
	tween:to(target, {x = -target.w, time = 50, onComplete=gameBG.cloudTweenComplete1})
end
function gameBG.cloudTweenComplete2(target)
	target.x = director.displayWidth *1.7
	tween:to(target, {x = -target.w, time = 80, onComplete=gameBG.cloudTweenComplete2})
end
function gameBG.cloudTweenComplete3(target)
	target.x = director.displayWidth *1.7
	tween:to(target, {x = -target.w, time = 150, onComplete=gameBG.cloudTweenComplete3})
end
function gameBG.cloudTweenComplete4(target)
	target.x = director.displayWidth *1.7
	tween:to(target, {x = -target.w, time = 100, onComplete=gameBG.cloudTweenComplete4})
end


function gameBG:createProp(propData)
	
	if self.props[propData.propId] == nil then
		--print(propData.propId ..  " " ..  PROPS[propData.propId].source .. " " .. PROPS[propData.propId].width .. " " .. PROPS[propData.propId].height .. " " .. PROPS[propData.propId].numFrames)
		self.props[propData.propId] = {}
		self.props[propData.propId].atlas = director:createAtlas({
			width = PROPS[propData.propId].width,
			height = PROPS[propData.propId].height,
			numFrames = PROPS[propData.propId].numFrames,
			textureName = PROPS[propData.propId].source,
		})
		
		local delay = 0

		if PROPS[propData.propId].numFrames > 1 then
			delay = 0.066
		end
		
		self.props[propData.propId].anim = director:createAnimation({
			start = PROPS[propData.propId].animStart,
			count = PROPS[propData.propId].animCount,
			atlas = self.props[propData.propId].atlas,
			delay = delay
		})
	end
	
	-- Ugly dirty hack to fix zOrder issue by moving everything at the top of the screen up 50 pixels to stop it drawing over trees and other objects on the field
	if propData.y > 100 then
		propData.y = propData.y + 50
	end
	
	return director:createSprite({xAnchor=0.5, yAnchor = 0.5, x = propData.x, y=propData.y, zOrder=PROPS[propData.propId].zOrder, source=self.props[propData.propId].anim, isTouchable=false})
end

